############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXRedis::BEGIN{package NXRedis;no warnings;require NXMsg;do{
"\x4e\x58\x4d\x73\x67"->import};}package NXRedis;no warnings;$selector;
$readRedis;$writeRedis;$daemonRedis;$clientRedis;($retry=(0x0efd+ 1172-0x1391));
($connected=(0x05a0+  71-0x05e7));($serverInit=(0x05b5+ 5899-0x1cc0));(
$multiCommand=(0x05c3+ 740-0x08a7));($resendSuccess=(0x08f6+ 1928-0x107e));(
$waitingConnect=(0x182b+ 1450-0x1dd5));($lockFileHandle=(-(0x1c0c+ 1326-0x2139))
);($redisServerPid=(-(0x00aa+ 3309-0x0d96)));($waitingForAcquireTimeout=
(0x0161+ 5074-0x147f));($waitingForReleaseCounter=(0x030d+ 4451-0x1470));(
$waitingForNewDaemonCounter=(0x07a3+ 4000-0x1743));($waitingForReleaseSendKill=
(0x061f+ 4724-0x1875));($waitingForRedisDaemonReply=(0x0101+ 8224-0x211e));(
$waitingForNonDaemonServerReleaseTimeout=(0x067d+ 1414-0x0b9f));(
$timeoutForNewDaemonWaiting=(0x10ec+ 3551-0x1ddb));($waitingForNewDaemonTick=0.5
);($failCounter=(0x1013+ 1644-0x167f));($finalizeProcessStarted=
(0x141a+ 2416-0x1d8a));($doNotCloseRedisThreadsWhenFreePerl=
(0x1adb+ 1846-0x2211));($waitForResponseTimeout=(0x09f7+ 6559-0x238c));(
$waitIntervalTime=0.1);($maxWaitTimeout=(0x06ea+ 3323-0x12b9));
@waitingCommandList;@responses;@sendCommandList;($descriptorLimit=
(0x210a+ 3872-0x202a));($errorDuringLastCommand=(0x0394+ 1453-0x0941));sub 
initRedisServer{if (($serverInit==(0x207b+ 1212-0x2537))){(my $cookie=
NXServerDaemon::getCookie ());setNxDirInNXHomeDirOwner ();if (
main::nxPipeCreateBi ((\$daemonRedis),(\$clientRedis))){Logger::debug (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x72\x65\x61\x74\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x5b"
.$daemonRedis)."\x2f").$clientRedis)."\x5d\x2e"));}else{Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);return;}(my $returnValue=libnxhs::NXRedisServerCreate ($daemonRedis,$cookie,
NXPaths::getRedisDatabaseDirectory (),NXPaths::getNXErrorFile ()));if ((
$returnValue==(0x1adf+ 2931-0x2651))){($serverInit=(0x0431+ 3857-0x1341));
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x2e"
);Common::NXCore::doNotCloseSocketAtFinish ($daemonRedis);}else{Logger::error ((
(
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x69\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x20\x65\x72\x72\x6f\x72\x20\x77\x69\x74\x68\x20\x72\x65\x74\x75\x72\x6e\x20\x76\x61\x6c\x75\x65\x3a\x20"
.$returnValue)."\x2e"));(my $error=libnxh::NXGetErrorName ());(my $errorstring=
libnxh::NXGetErrorString ());Logger::error (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20".
$error)."\x3a\x20").$errorstring)."\x2e"));main::nxexit ();}}elsif ((not (
checkRedisFlock ()))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x73\x65\x72\x76\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x6f\x6e\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);removeRedisServerLockFileHandle ();}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x73\x65\x72\x76\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x6f\x6e\x20\x74\x68\x69\x73\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);}}sub auth{my ($cookie);if (($serverInit==(0x1314+ 136-0x139c))){($cookie=
NXClientSystemDaemons::getCookieForRedisAuthentication ());}else{($cookie=
NXServerDaemon::getCookie ());}if (($cookie ne (""))){sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x61\x75\x74\x68\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d"
.$cookie)."\x0a"));(my $returnValue=get ());if (($returnValue ne "\x4f\x4b")){
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x41\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x72\x65\x74\x75\x72\x6e\x20\x76\x61\x6c\x75\x65\x3a\x20"
.$returnValue)."\x2e"));forceCloseRedisClient ();checkFailCounter ();return (
(0x145b+ 4417-0x259b));}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x64\x2e"
);($failCounter=(0x0d39+ 6056-0x24e1));return ((0x1ee1+ 323-0x2024));}}else{
forceCloseRedisClient ();checkFailCounter ();Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x41\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x69\x6f\x6e\x20\x63\x6f\x6f\x6b\x69\x65\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2c\x20\x63\x61\x6e\x6e\x6f\x74\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((0x15d5+ 2405-0x1f39));}}sub initRedisClient{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x49\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);if ((($readRedis eq (""))or ($writeRedis eq ("")))){if (
libnxhs::NXRedisClientRunning ()){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x72\x65\x61\x74\x65\x64\x2e"
);Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x53\x75\x62\x73\x79\x73\x74\x65\x6d\x47\x65\x74\x52\x65\x64\x69\x73\x46\x64\x28\x29"
);(my $FD=libnxhs::NXSubsystemGetRedisFd ());Logger::debug2 (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x53\x75\x62\x73\x79\x73\x74\x65\x6d\x47\x65\x74\x52\x65\x64\x69\x73\x46\x64\x28\x29\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$FD)."\x27\x2e"));if (($FD>=(0x046a+ 651-0x06f5))){($connected=
(0x1fc1+ 989-0x239d));($readRedis=$FD);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x69\x6e\x68\x65\x72\x69\x74\x65\x64\x20\x46\x44\x23"
.$FD)."\x2e"));($selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;$selector->add ($readRedis);$selector->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});}else{Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x52\x65\x64\x69\x73\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x2e"
);}if (checkIfSubscriptionShouldBeStarted ()){main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::createSubscriptionClient ();}return;}if ((not (
main::nxPipeCreateBi ((\$readRedis),(\$writeRedis))))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);return ((0x03c8+ 152-0x0460));}(my $homeDir=NXPaths::getUserNXHomeDir ());
libnxh::NXTransSetEnvironment ("\x48\x4f\x4d\x45",$homeDir);Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x72\x65\x61\x74\x65\x28"
.$writeRedis)."\x2c\x20").$writeRedis)."\x29"));(my $rettmp=
libnxhs::NXRedisCreate ($writeRedis,$writeRedis));Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x72\x65\x61\x74\x65\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$rettmp)."\x27\x2e"));Common::NXCore::doNotCloseSocketAtFinish ($writeRedis);}(
$selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;$selector->add ($readRedis);$selector->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});if (($serverInit==(0x049f+ 5162-0x18c9))){if ((
NXClientSystemDaemons::openConnection ((0x0b79+ 4600-0x1d70))!=
(0x06ca+ 7367-0x2390))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x1c02+ 512-0x1e02));}if (main::nxPipeCreateBi ((\$daemonRedis),(
\$clientRedis))){Logger::debug (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x72\x65\x61\x74\x65\x64\x20\x73\x65\x63\x6f\x6e\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x5b"
.$daemonRedis)."\x2f").$clientRedis)."\x5d\x2e"));}else{Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x73\x65\x63\x6f\x6e\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);return ((0x182b+ 3293-0x2508));}(my $socketCookie=main::get_unique_id ());(my $tmpDir
=NXPaths::getTmpDir ());(my $socketPath=(($tmpDir.$GLOBAL::DIRECTORY_SLASH).
main::get_unique_id ()));(my $message=(("\x4e\x58\x3e\x20".
$GLOBAL::MSG_REDIS_YIELD)."\x20\x52\x65\x64\x69\x73\x20\x79\x69\x65\x6c\x64"));(
$message.=("\x20\x70\x69\x64\x3d".$ $));
 ($message.=(
"\x20\x73\x6f\x63\x6b\x65\x74\x50\x61\x74\x68\x45\x6e\x63\x6f\x64\x65\x64\x3d".
main::urlencode ($socketPath)));($message.=(
"\x20\x73\x6f\x63\x6b\x65\x74\x43\x6f\x6f\x6b\x69\x65\x3d".$socketCookie));(
$message.=("\x20\x66\x64\x3d".$daemonRedis));($message.="\x20\x0a");if ((
NXClientSystemDaemons::sendMessage ($message)!=(0x0735+ 1577-0x0d5d))){
Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x0f02+ 4670-0x2140));}Server::saveTimestamp (
"\x72\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x41\x63\x71\x75\x69\x72\x65",
"\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x63\x71\x75\x69\x72\x65\x2e"
);(my $response=NXClientSystemDaemons::getDaemonReplyAboutRedis (
$waitingForAcquireTimeout));if (($response ne getMessageStartAcquire ())){if ((
$response eq (""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x74\x69\x6d\x65\x6f\x75\x74\x3a\x20"
.$waitingForAcquireTimeout)."\x20\x72\x65\x61\x63\x68\x65\x64\x2e"));}else{
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x72\x65\x61\x64\x79\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20"
.$response)."\x2e"));}NXClientSystemDaemons::closeConnection ();return (
(0x00fd+ 756-0x03f1));}if ((Common::NXDescriptor::yield ($daemonRedis,
$socketPath,$socketCookie)==(-(0x0e10+ 887-0x1186)))){Logger::error (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x79\x69\x65\x6c\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x46\x44\x23"
.$daemonRedis).
"\x20\x77\x69\x74\x68\x20\x73\x6f\x63\x6b\x65\x74\x20\x70\x61\x74\x68\x20").
$socketPath)."\x2e"));NXClientSystemDaemons::closeConnection ();main::nxexit (
(0x1759+ 3165-0x23b5));}($response=(""));($response=
NXClientSystemDaemons::getDaemonReplyAboutRedis ($waitingForRedisDaemonReply));
if (($response eq getMessageAcquireFail ())){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x66\x61\x69\x6c\x65\x64\x2e"
);NXClientSystemDaemons::closeConnection ();main::nxexit ((0x1880+ 1834-0x1fa9))
;}if (($response ne getMessageAcquireDone ())){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x64\x75\x72\x69\x6e\x67\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x3a\x20"
.$response)."\x2e"));NXClientSystemDaemons::closeConnection ();return (
(0x0531+ 7036-0x20ad));}Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4e\x58\x52\x65\x64\x69\x73\x41\x63\x71\x75\x69\x72\x65\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x66\x74\x65\x72\x20"
.Server::getTimePassedFromSavedTimestamp (
"\x72\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x41\x63\x71\x75\x69\x72\x65")).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));
Common::NXCore::doNotCloseSocketAtFinish ($daemonRedis);
NXClientSystemDaemons::closeConnection ();Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x70\x61\x73\x73\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x74\x6f\x20\x74\x68\x65\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);}($connected=(0x0ac7+ 4459-0x1c31));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6f\x6e\x6e\x65\x63\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x66\x64\x3d"
.$clientRedis)."\x0a"));if ((get ()eq "\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64")){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e"
);Common::NXCore::doNotCloseSocketAtFinish ($clientRedis);if ((auth ()==
(0x18a1+ 2947-0x2423))){return (initRedisClient ());}($redisServerPid=
__getRedisServerPid ());if (($serverInit==(0x0459+ 804-0x077c))){main::nxrequire
 ("\x4e\x58\x52\x65\x64\x69\x73\x53\x63\x72\x69\x70\x74");
NXRedisScript::loadAllScriptsToDb ();}if (checkIfSubscriptionShouldBeStarted ())
{main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::createSubscriptionClient ();}}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e"
);}}sub sendToDb{(my $msg=shift (@_));if ((Server::isDaemonProcess ()and (
$serverInit==(0x030b+ 889-0x0684)))){if ((
NXServerDaemon::checkAndSetServerDaemonFlock ()==(0x157d+ 854-0x18d3))){
Logger::error (
"\x41\x6e\x6f\x74\x68\x65\x72\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x69\x6e\x73\x74\x61\x6e\x63\x65\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);main::nxexit ();}main::nxrequire (
"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73");if (
NXSystemDaemons::savePid ("\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 Logger::error
 (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x61\x76\x65\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x70\x69\x64\x2e"
);main::nxexit ();}if ((__checkAndSetRedisServerFlock ()==(0x0d8b+ 4821-0x205f))
){initRedisServer ();($waitingForReleaseCounter=(0x1b4a+ 430-0x1cf8));}else{if (
($waitingForReleaseCounter>$waitingForReleaseSendKill)){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e\x20\x45\x78\x69\x74\x69\x6e\x67\x2e"
);main::nxexit ((0x0146+ 4486-0x12cc));}if (($waitingForReleaseCounter==
$waitingForReleaseSendKill)){(my $redisServerPid=__getRedisServerPid ());
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x6b\x69\x6c\x6c\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$redisServerPid).
"\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
));__killOtherRedisServer ($redisServerPid);}Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4f\x74\x68\x65\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x69\x73\x20\x63\x75\x72\x72\x65\x6e\x74\x6c\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);main::nxsleep (0.5);(++$waitingForReleaseCounter);return (sendToDb ($msg));}}
main::nxrequire ("\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73")
;if ((((((($connected==(0x0abc+ 731-0x0d97))and (NXSystemDaemons::isShutdownFlag
 ()==(0x04a7+ 2716-0x0f43)))and ($redisServerPid!=(-(0x068b+ 7577-0x2423))))and 
($serverInit==(0x16d1+ 3459-0x2454)))and (NXServerDaemon::checkDaemonFlock ()==
(0x0405+ 8782-0x2652)))and ($finalizeProcessStarted==(0x0568+ 5782-0x1bfe)))){(
++$waitingForNewDaemonCounter);main::nxsleep ($waitingForNewDaemonTick);if ((
$waitingForNewDaemonCounter>=$timeoutForNewDaemonWaiting)){($redisServerPid=(-
(0x09b6+ 4021-0x196a)));(my $logTimeout=($waitingForNewDaemonCounter *
$waitingForNewDaemonTick));($waitingForNewDaemonCounter=(0x1009+ 236-0x10f5));
Logger::error (((
"\x53\x65\x72\x76\x65\x72\x20\x6c\x6f\x73\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x61\x6e\x64\x20\x74\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x6e\x65\x77\x20\x6f\x6e\x65\x20"
.$logTimeout).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x20\x72\x65\x61\x63\x68\x65\x64\x2e"));closeDb
 ((0x0031+ 7431-0x1d37));main::nxexit ((0x0191+ 3315-0x0e83));}else{return (
sendToDb ($msg));}}($waitingForNewDaemonCounter=(0x0db5+ 1309-0x12d2));if ((((
$connected==(0x0478+ 6467-0x1dbb))and ($serverInit==(0x19c8+ 2033-0x21b9)))and (
not (Server::isDaemonProcess ())))){if ((NXSystemDaemons::isShutdownFlag ()==
(0x09c4+ 4579-0x1ba6))){if ((__checkAndSetRedisServerFlock ()==
(0x0445+ 6705-0x1e75))){initRedisServer ();($waitingForReleaseCounter=
(0x1b15+  18-0x1b27));}else{removeRedisServerLockFileHandle ();if ((
$waitingForReleaseCounter==$waitingForNonDaemonServerReleaseTimeout)){
Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x6f\x6e\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e"
);return ((0x08aa+ 3753-0x1753));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x6f\x6e\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x2e\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x62\x75\x74\x20\x74\x68\x65\x72\x65\x20\x69\x73\x20\x6c\x6f\x63\x6b\x20\x6f\x6e\x20\x66\x69\x6c\x65\x2e"
);main::nxsleep ($waitIntervalTime);(++$waitingForReleaseCounter);return (
sendToDb ($msg));}}elsif ((NXServerDaemon::checkDaemonFlock ()==
(0x1440+ 1905-0x1bb0))){if ((($GLOBAL::isNXServerLoginProcess==
(0x0724+ 3695-0x1593))or (($GLOBAL::isNXServerLoginProcess==
(0x0879+ 5871-0x1f67))and ($finalizeProcessStarted==(0x1970+ 447-0x1b2e))))){if 
((__checkAndSetRedisServerFlock ()==(0x183f+  20-0x1852))){initRedisServer ();(
$waitingForReleaseCounter=(0x0b84+ 2692-0x1608));}else{
removeRedisServerLockFileHandle ();if (($waitingForReleaseCounter==
$waitingForNonDaemonServerReleaseTimeout)){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e"
);return ((0x05dc+ 7709-0x23f9));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x62\x75\x74\x20\x74\x68\x65\x72\x65\x20\x69\x73\x20\x6c\x6f\x63\x6b\x20\x6f\x6e\x20\x66\x69\x6c\x65\x2e"
);main::nxsleep ($waitIntervalTime);(++$waitingForReleaseCounter);return (
sendToDb ($msg));}}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x61\x73\x20\x6c\x6f\x67\x69\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);checkFailCounter ();return ((0x0004+ 6097-0x17d5));}}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);}}if (($connected==(0x005c+ 6035-0x17ef))){initRedisClient ();}if (($connected
==(0x0d35+ 134-0x0dbb))){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$msg).
"\x27\x2e\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e"
));return ((0x114c+ 5005-0x24d9));}if ((__checkCommandLine ((\$msg))==
(0x16d6+ 632-0x194d))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$msg)."\x27\x20\x61\x62\x6f\x72\x74\x65\x64\x2e"));return (
(0x17d7+ 1059-0x1bfa));}Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x27".$msg)
."\x27\x2e"));if ((main::nxwrite ($readRedis,$msg)==(-(0x1ad0+ 1535-0x20ce)))){
if (($retry==(0x1912+ 1153-0x1d93))){closeDb ();($retry=(0x1865+ 1725-0x1f21));
sendToDb ($msg);}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$msg).
"\x27\x2e\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e"
));return ((0x15f9+ 447-0x17b8));}}($retry=(0x0887+ 716-0x0b53));push (
@sendCommandList,$msg);return ((0x0f8a+ 4873-0x2292));}sub sendToDbAndSave{(my $msg
=shift (@_));if ((sendToDb ($msg)==(0x0715+ 2623-0x1153))){saveDb ();}}sub 
sendToDbAndGetReply{(my $request=shift (@_));if ((sendToDb ($request)==
(0x1b69+ 1133-0x1fd5))){return (split ( / / ,get (),(0x1cab+ 1857-0x23ec)));}
return (undef);}sub readFromDb{my ($read_buf);(my $bytes_read=main::nxread (
$readRedis,(\$read_buf),32768));if ((($bytes_read eq (0x21f2+ 807-0x2519))or (
$bytes_read eq ("")))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x031a+ 9201-0x270b));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x63\x65\x69\x76\x65\x64\x20\x64\x61\x74\x61\x20\x6f\x6e\x20\x52\x65\x64\x69\x73\x20\x73\x6f\x63\x6b\x65\x74\x3a\x20\x27"
.$response)."\x27\x2e"));parseRedisOutput ($response);}}sub get{(my $callbackTimeout
=(shift (@_)||(0x0908+ 5224-0x1d70)));(my $ref_timeoutCallback=shift (@_));if ((
$sendCommandList[-(0x1879+ 2114-0x20ba)]eq (""))){return ((""));}push (
@waitingCommandList,$sendCommandList[-(0x0790+ 5548-0x1d3b)]);(my $tmpLastCommand
=__getCommandNameFromLine ($sendCommandList[-(0x0918+ 1991-0x10de)]));my (
$returnValue);if ((waitForReponse ($callbackTimeout,$ref_timeoutCallback)==
(0x0cf4+ 5111-0x20ea))){($returnValue=pop (@responses));($failCounter=
(0x08fb+ 4706-0x1b5d));Logger::debug3 (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x27"
.$tmpLastCommand)."\x27\x20\x69\x73\x20\x27").$returnValue)."\x27\x2e"));}else{
if ((checkFailure ()==(0x08cb+ 237-0x09b8))){if ((waitForReponse (
$callbackTimeout,$ref_timeoutCallback)==(0x1a26+ 161-0x1ac6))){($returnValue=pop
 (@responses));($failCounter=(0x2356+ 495-0x2545));Logger::debug3 (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x27"
.$tmpLastCommand)."\x27\x20\x69\x73\x20\x27").$returnValue)."\x27\x2e"));}else{(
@waitingCommandList=());(@responses=());shift (@sendCommandList);Logger::error (
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x75\x74\x70\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$tmpLastCommand).
"\x20\x61\x66\x74\x65\x72\x20\x72\x65\x73\x65\x6e\x64\x69\x6e\x67\x2e"));}}else{
Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x75\x74\x70\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$tmpLastCommand).
"\x20\x52\x65\x73\x65\x6e\x64\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x73\x20\x66\x61\x69\x6c\x65\x64\x2e"
));}}return ($returnValue);}sub getWithCallbackOnTimeout{(my $callbackTimeout=
shift (@_));(my $ref_timeoutCallback=shift (@_));if (($maxWaitTimeout<
$callbackTimeout)){return (get ());}(my $defaultTimeout=$waitForResponseTimeout)
;($waitForResponseTimeout=$maxWaitTimeout);(my $result=get ($callbackTimeout,
$ref_timeoutCallback));($waitForResponseTimeout=$defaultTimeout);return ($result
);}sub waitForReponse{(my $callbackTimeout=(shift (@_)||(0x1090+ 3421-0x1ded)));
(my $ref_timeoutCallback=shift (@_));(my $waitTime=(0x0077+ 8742-0x229d));(my $waitForResponseTimeout
=($waitForResponseTimeout *(0x1ba6+ 3127-0x23f5)));(my $maxSelectTimeout=
$waitForResponseTimeout);if ($callbackTimeout){($maxSelectTimeout=
$callbackTimeout);}if (((__getCommandNameFromLine ($waitingCommandList[
(0x0a83+ 5044-0x1e37)])eq "\x61\x75\x74\x68")or (__getCommandNameFromLine (
$waitingCommandList[(0x1fb3+ 547-0x21d6)])eq "\x65\x76\x61\x6c\x73\x68\x61"))){(
$waitForResponseTimeout=(($NXRedis::waitForResponseTimeout *
(0x153c+ 1626-0x17ae))*(0x0d41+ 299-0x0e66)));($maxSelectTimeout=
$waitForResponseTimeout);}($selectTimeout=$maxSelectTimeout);(my $startTime=
Common::NXTime::getMillisecondsSinceEpoch ());(my $lastTimeoutCallbackCall=
(0x07c6+ 6816-0x2266));while (((@waitingCommandList and ($waitTime<
$waitForResponseTimeout))and (($connected==(0x03fa+ 3336-0x1101))||(
__getCommandNameFromLine ($waitingCommandList[(0x038d+ 3962-0x1307)])eq 
"\x63\x6f\x6e\x6e\x65\x63\x74")))){(my (@ready)=$selector->can_read (
$selectTimeout));foreach my $fh (@ready){if (($fh eq $readRedis)){if (
@waitingCommandList){readFromDb ();}}}if (@waitingCommandList){if ((
$resendSuccess==(0x1db3+ 2377-0x26fb))){($waitTime=(0x1270+ 3657-0x20b9));(
$selectTimeout=$maxSelectTimeout);($startTime=
Common::NXTime::getMillisecondsSinceEpoch ());($resendSuccess=
(0x0b55+ 156-0x0bf1));}else{($waitTime=(
Common::NXTime::getMillisecondsSinceEpoch ()-$startTime));if ($callbackTimeout){
if ((($waitTime+$selectTimeout)>$waitForResponseTimeout)){($selectTimeout=(
$waitForResponseTimeout-$waitTime));}}else{($selectTimeout=($maxSelectTimeout-
$waitTime));}}if ($callbackTimeout){if ((($lastTimeoutCallbackCall+
$callbackTimeout)<Common::NXTime::getSecondsSinceEpoch ())){&{
$ref_timeoutCallback;}();($lastTimeoutCallbackCall=
Common::NXTime::getSecondsSinceEpoch ());}}}}if (($connected!=
(0x1c91+ 1500-0x226c))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x69\x65\x6e\x74\x20\x77\x61\x73\x20\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2c\x20\x71\x75\x69\x74\x20\x77\x61\x69\x74\x69\x6e\x67\x2e"
);return ((0x137f+ 4337-0x2470));}if (@waitingCommandList){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x54\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.__getCommandNameFromLine ($waitingCommandList[(0x04a2+ 2349-0x0dcf)])).((
"\x20\x77\x68\x69\x63\x68\x20\x69\x73\x20".$NXRedis::waitForResponseTimeout).
"\x20\x68\x61\x73\x20\x62\x65\x65\x6e\x20\x72\x65\x61\x63\x68\x65\x64\x2e")));
checkFailCounterAndCloseIfNeeded ();return ((0x22b5+ 251-0x23b0));}return (
(0x0777+ 760-0x0a6e));}sub parseRedisOutput{(my $output=shift (@_));($output.=
"\x20");(my (@lines)=split ( /\n/ ,$output,(0x14b0+ 3332-0x21b4)));while (@lines
){(my $line=shift (@lines));if (($line=~ /event=disconnected,error=0/ )){(
$connected=(0x1679+ 3428-0x23dd));next;}(my $response=shift (@lines));unless (
@sendCommandList){return;}my ($firstWaitingCommand);if (@waitingCommandList){(
$firstWaitingCommand=__getCommandNameFromLine ($waitingCommandList[
(0x0904+ 1296-0x0e14)]));}if ((handleCommandSuccesful ($line)==
(0x0b26+ 953-0x0ede))){return;}if (($line=~ /command=connect,error=0/ )){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e");
($connected=(0x07a6+ 7514-0x24ff));shift (@waitingCommandList);push (@responses,
"\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");next;}elsif (($line=~ /command=connect,error=/ )
){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x2e"
);shift (@waitingCommandList);push (@responses,
"\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");($connected=
(0x266f+   4-0x2673));next;}elsif ((($line=~ /command=(.*),error=0/ )and (
$response ne ("")))){(my $command=$1);if (($command eq $firstWaitingCommand)){(my $fullResponse
=$response);if (($command eq "\x63\x6c\x69\x65\x6e\x74")){while ((@lines and (
$lines[(0x0e85+ 2309-0x178a)]=~ /^id=/ ))){($fullResponse.=("\x0a".shift (@lines
)));}}push (@responses,$fullResponse);shift (@waitingCommandList);next;}else{
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$firstWaitingCommand)."\x2e"));}}elsif ((($line=~ /command=(.*),error=0,size=0/ )
and ($response eq ("")))){(my $command=$1);if (($command eq $firstWaitingCommand
)){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6e\x6f\x20\x76\x61\x6c\x75\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.__getCommandNameFromLine ($waitingCommandList[(0x138a+ 591-0x15d9)])).
"\x20\x73\x61\x76\x65\x64\x20\x69\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"))
;push (@responses,(""));shift (@waitingCommandList);next;}else{Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$firstWaitingCommand)."\x2e"));}}elsif ((($line=~ /command=bgsave,error=1/ )and
 ($response=~ /ERR Background save already in progress/ ))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x61\x76\x69\x6e\x67\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x69\x6e\x20\x70\x72\x6f\x67\x72\x65\x73\x73\x2c\x20\x73\x6b\x69\x70\x69\x6e\x67\x2e"
);push (@responses,(""));shift (@waitingCommandList);shift (@sendCommandList);
next;}elsif (($line=~ /command=(.*),error=(.*)/ )){(my $error=$2);(
$errorDuringLastCommand=(0x1b0b+ 1134-0x1f78));if (($error ne (""))){if ((
__handleRedisErrorIfPossible ($response)==(0x17e2+  80-0x1831))){return;}
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x27".
__getCommandNameFromLine ($sendCommandList[(0x0786+ 6851-0x2249)])).((((
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x20\x72\x65\x64\x69\x73\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$error)."\x3a\x20").$response).
"\x20\x4d\x6f\x72\x65\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x20\x69\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x2e"
)));}else{Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x27".
__getCommandNameFromLine ($sendCommandList[(0x0ac1+ 7193-0x26da)])).
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x20\x72\x65\x64\x69\x73\x2e\x20\x4d\x6f\x72\x65\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x20\x69\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x2e"
));}($connected=(0x0021+ 6669-0x1a2e));}elsif (($line eq (""))){next;}elsif ((
$response=~ /event=disconnected,error=0/ )){($connected=(0x0efc+ 4265-0x1fa5));
next;}}}sub getRedisDescriptor{return ($readRedis);}sub saveDb{Logger::debug (
"\x53\x61\x76\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);if (($serverInit==(0x09dd+ 1866-0x1126))){sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x61\x76\x65\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}else{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x62\x67\x73\x61\x76\x65\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}(my $saveResponse=get ());}sub closeDb{(my $finalizeProcess=(shift (@_)||
(0x0a3c+ 1509-0x1021)));if (($finalizeProcess==(0x1952+ 1718-0x2007))){(
$finalizeProcessStarted=(0x01af+ 6183-0x19d5));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x64\x62\x2e"
);while ((scalar (@sendCommandList)>(0x037a+ 5616-0x196a))){(my $command=
__getCommandNameFromLine ($sendCommandList[(0x138d+ 2953-0x1f16)]));
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$command).
"\x27\x20\x62\x65\x66\x6f\x72\x65\x20\x63\x6c\x6f\x73\x69\x6e\x67\x2e"));get ();
}if (($doNotCloseRedisThreadsWhenFreePerl==(0x00b2+ 8352-0x2151))){Logger::debug
 (
"\x4c\x65\x61\x76\x69\x6e\x67\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x6e\x64\x20\x72\x65\x64\x69\x73\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x74\x68\x72\x65\x61\x64\x2e"
);return;}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::closeSubscription ();if (($connected==(0x0925+ 1119-0x0d83)
)){Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x44\x65\x73\x74\x72\x6f\x79\x28\x29"
);(my $returnValue=libnxhs::NXRedisClientDestroy ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x44\x65\x73\x74\x72\x6f\x79\x28\x29\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$returnValue)."\x27\x2e"));Common::NXSelector::removeFromGlobalSelector (
$readRedis);($readRedis=(""));($connected=(0x08d8+ 2601-0x1301));}if ((
$serverInit==(0x2081+ 121-0x20f9))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);if ((libnxhs::NXRedisServerDestroy ()==(0x0bb2+ 926-0x0f4f))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);removeRedisServerLockFileHandle ();(my $redisLock=getRedisLockFile ());if ((
not (unlink ($redisLock)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}(my $redisPidFile=getRedisPidFile ());if ((not (
unlink ($redisPidFile)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}(my $dbFile=NXPaths::getRedisDatabaseFile ());if 
(Common::NXFile::fileExists ($dbFile)){my ($errorMsg);if ((
Common::NXFile::setOwnershipForUserNX ($dbFile,(\$errorMsg))==(-
(0x0006+ 9589-0x257a)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x72\x65\x64\x69\x73\x20\x66\x69\x6c\x65\x20\x27"
.$dbFile)."\x27\x20").$errorMsg)."\x2e"));}}}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x63\x6c\x6f\x73\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);}($serverInit=(0x0301+ 6597-0x1cc6));}}sub isRedisDatabaseInit{if (
Server::isDaemonProcess ()){if (($serverInit==(0x1f03+ 452-0x20c6))){return (
(0x1616+ 2524-0x1ff1));}else{return ((0x1184+ 573-0x13c1));}}if (
isRedisLockFileExist ()){return ((0x1a4b+ 413-0x1be7));}else{return (
(0x04c8+ 6005-0x1c3d));}}sub getRedisLockFile{(my $redisLockFile=((((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x64\x62").$GLOBAL::DIRECTORY_SLASH
)."\x73\x65\x72\x76\x65\x72").$GLOBAL::DIRECTORY_SLASH)."\x72\x65\x64\x69\x73"))
;return ($redisLockFile);}sub getRedisPidFile{(my $redisPidFile=((((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x64\x62").$GLOBAL::DIRECTORY_SLASH
)."\x73\x65\x72\x76\x65\x72").$GLOBAL::DIRECTORY_SLASH).
"\x72\x65\x64\x69\x73\x2e\x70\x69\x64"));return ($redisPidFile);}sub 
isRedisLockFileExist{(my $file=getRedisLockFile ());if (
Common::NXFile::fileExists ($file)){return ((0x12b0+ 980-0x1683));}else{return (
(0x12d3+ 4290-0x2395));}}sub isNotRedisDatabaseInit{return ((!
isRedisDatabaseInit ()));}sub daemonAcquire{(my $message=shift (@_));(my $socket
=shift (@_));(my (%parameters)=());(my $redisDescriptor=(-(0x1484+ 2718-0x1f21))
);if (($serverInit==(0x0eeb+ 530-0x10fd))){return ((0x0839+ 7825-0x26c9));}if ((
$message=~ /Redis yield/ )){($message=~ s/Redis yield // );(my (@args)=split ( / / ,
$message,(0x0d7a+ 861-0x10d7)));foreach my $pair (@args){(my ($key,$value)=split
 ( /=/ ,$pair,(0x07f0+ 5289-0x1c96)));($parameters{$key}=$value);}(my $socketPath
=main::urldecode ($parameters{
"\x73\x6f\x63\x6b\x65\x74\x50\x61\x74\x68\x45\x6e\x63\x6f\x64\x65\x64"}));(my $msg
=getMessageStartAcquire ());if ((main::nxwrite ($socket,$msg)==(-
(0x1d12+ 1663-0x2390)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x72\x65\x61\x64\x79\x2e"
));return ((0x0ec2+ 2749-0x197e));}($redisDescriptor=
Common::NXDescriptor::acquire ($parameters{"\x70\x69\x64"},$parameters{
"\x66\x64"},$socketPath,$parameters{
"\x73\x6f\x63\x6b\x65\x74\x43\x6f\x6f\x6b\x69\x65"}));if ((($redisDescriptor<
(0x0113+ 4609-0x1314))or ($redisDescriptor>$descriptorLimit))){Logger::warning (
((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x66\x72\x6f\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"})."\x20\x61\x6e\x64\x20").$socketPath)."\x2e"));(
$msg=getMessageAcquireFail ());if ((main::nxwrite ($socket,$msg)==(-
(0x0fe2+ 1464-0x1599)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x66\x61\x69\x6c\x2e"
));}return ((0x0173+ 3916-0x10be));}Common::NXCore::doNotCloseSocketAtFinish (
$redisDescriptor);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x72\x65\x63\x65\x69\x76\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x46\x44\x23"
.$redisDescriptor)."\x20\x66\x72\x6f\x6d\x20\x73\x65\x72\x76\x65\x72\x2e"));(my $return
=libnxhs::NXRedisServerConnection ($redisDescriptor));Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x28"
.$redisDescriptor)."\x29\x20").$return)."\x2e"));($msg=getMessageAcquireDone ())
;if ((main::nxwrite ($socket,$msg)==(-(0x1c48+ 1008-0x2037)))){Logger::warning (
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x6f\x6e\x65\x2e"
));}return ((0x2129+ 630-0x239f));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x68\x61\x6e\x64\x6c\x65\x20\x72\x65\x64\x69\x73\x20\x79\x69\x65\x6c\x64\x20\x72\x65\x71\x75\x65\x73\x74\x3a\x20"
.$message)."\x2e"));return ((0x20d0+ 852-0x2423));}}sub 
isDbRunningInCurrentProcess{return ($serverInit);}sub __lockFile{(my $file=
getRedisLockFile ());my ($errormsg);(my $SERVER_FH=main::nxopen ($file,(
$NXBits::O_WRONLY+$NXBits::O_CREAT),(($NXBits::UserReadWrite+$NXBits::GroupRead)
+$NXBits::OthersRead)));if ((not (defined ($SERVER_FH)))){(my $serverDir=
Common::NXFile::dirname ($file));if ((Common::NXFile::directoryExists (
$serverDir)==(0x1bfa+ 421-0x1d9f))){my ($errorMessage);if (
Common::NXPaths::makePath ((\$errorMessage),$serverDir)){if ((
Common::NXFile::setOwnershipForUserNX ($serverDir,(\$errorMessage))==(-
(0x09a7+ 2960-0x1536)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x4e\x58\x20\x66\x6f\x72\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}if ((Common::NXFile::setPermissionsFullForNXDirectory ($serverDir,(
\$errorMessage))==(-(0x0300+ 5370-0x17f9)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20\x4e\x58\x20\x66\x6f\x72\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}($SERVER_FH=main::nxopen ($file,($NXBits::O_WRONLY+$NXBits::O_CREAT),(
($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)));}else{
Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}}if ((not (defined ($SERVER_FH)))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x20\x66\x6f\x72\x20\x77\x72\x69\x74\x69\x6e\x67\x2e"));return ((-
(0x0ea6+ 1270-0x139b)));}}unless (main::nxflock ($SERVER_FH,$NXBits::LOCK_EX)){
Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x3a\x20"
.$file)."\x2e"));return ((-(0x01e0+ 2130-0x0a31)));}
Common::NXFile::setOwnershipForUserNX ($file,(\$errormsg));if (($errormsg ne 
(""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errormsg)."\x2e"));}libnxh::NXDescriptorInheritable ($SERVER_FH,
(0x193d+ 792-0x1c55));main::closeSocketAtFinish ($SERVER_FH);return ($SERVER_FH)
;}sub __checkAndSetRedisServerFlock{if (($serverInit==(0x0389+ 3020-0x0f54))){
return ((0x1289+ 4732-0x2505));}if ((not (checkRedisFlock ()))){return (
(0x103c+ 5536-0x25dc));}else{unless ((main::effectiveUserIsAdministrator ()or (
Common::NXCore::getEffectiveUsername ()eq "\x6e\x78"))){if ((
NXSystemDaemons::isShutdownFlag ()==(0x0a4c+ 6581-0x2400))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x69\x6e\x75\x65\x2c\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x69\x73\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x20\x61\x6e\x64\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6f\x70\x65\x72\x61\x74\x69\x6f\x6e\x20\x72\x65\x71\x75\x69\x72\x65\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4e\x78\x73\x65\x72\x76\x65\x72\x53\x68\x75\x74\x64\x6f\x77\x6e"
,"\x4e\x58\x52\x65\x64\x69\x73");main::nxexit ((0x0bad+ 679-0x0e54));}}(my $file
=getRedisLockFile ());unlink ($file);(my $fh=__lockFile ());if (($fh==(-
(0x0645+ 4386-0x1766)))){return ((0x038c+ 4181-0x13e1));}
setRedisServerLockFileHandle ($fh);saveRedisPid ();return ((0x0957+ 151-0x09ed))
;}}sub checkRedisFlock{if (($serverInit==(0x14b7+ 979-0x1889))){return (
(0x133d+ 3615-0x215c));}(my $file=getRedisLockFile ());Logger::debug (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x66\x69\x6c\x65\x20\x6c\x6f\x63\x6b\x3a\x20"
.$file)."\x2e"));if ((Common::NXFile::fileExists ($file)==(0x12d0+ 2817-0x1dd1))
){Logger::debug ((("\x46\x69\x6c\x65\x20".$file).
"\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));return (
(0x00a7+ 985-0x047f));}(my $SERVER_FH=main::nxopen ($file,$NXBits::O_RDONLY,
(0x260a+  20-0x261e)));if ((not (defined ($SERVER_FH)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x3a\x20".$file
)."\x2e"));return ((0x0184+ 7251-0x1dd7));}if ((not (Common::NXCore::nxTryLock (
$SERVER_FH,$NXBits::LOCK_EX)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x3a\x20".$file
)."\x2e"));main::nxclose ($SERVER_FH);if ((not (Server::isDaemonProcess ()))){
checkFailCounter ();}return ((0x13f3+ 404-0x1587));}main::nxclose ($SERVER_FH);
return ((0x0f36+ 2749-0x19f2));}sub removeRedisServerLockFileHandle{if ((
$lockFileHandle!=(-(0x0042+ 4574-0x121f)))){main::nxclose ($lockFileHandle);(
$lockFileHandle=(-(0x1587+ 450-0x1748)));}}sub setRedisServerLockFileHandle{(
$lockFileHandle=shift (@_));}sub setNxDirInNXHomeDirOwner{(my $path=
NXPaths::getUserNXHomeDir ());my ($errorMsg);if (($path eq (""))){return (
(0x0715+ 5546-0x1cbf));}if ((Common::NXFile::directoryExists ($path)==
(0x1019+ 298-0x1143))){if ((not (Common::NXPaths::makePath ((\$errorMsg),$path))
)){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$path)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMsg)."\x2e"));
return ((0x0ac7+ 1108-0x0f1b));}}Common::NXFile::setOwnershipForUserNX ($path,(
\$errorMsg));Common::NXFile::setPermissionsFullForNXDirectory ($path,(\$errorMsg
));libnxh::NXTransSetEnvironment ("\x48\x4f\x4d\x45",$path);($path.=(
$GLOBAL::DIRECTORY_SLASH."\x2e\x6e\x78"));if ((Common::NXFile::directoryExists (
$path)==(0x0e58+ 2549-0x184d))){Common::NXPaths::createAccessibleForNXDirectory 
((\$errorMsg),$path);}else{Common::NXFile::setOwnershipForUserNX ($path,(
\$errorMsg));Common::NXFile::setPermissionsFullForNXDirectory ($path,(\$errorMsg
));}}sub getMessageStartAcquire{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x73\x74\x61\x72\x74\x65\x64\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x2e"
);return ($msg);}sub getMessageAcquireDone{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x64\x64\x65\x64\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x2e"
);return ($msg);}sub getMessageAcquireFail{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x63\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x61\x64\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x2e"
);return ($msg);}sub __killOtherRedisServer{(my $serverPid=shift (@_));if (
NXTerminate::checkProcessBeforeKill ($serverPid,
"\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 if (Common::NXProcess::sigterm (
$serverPid)){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x64\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}(my $result=Common::NXProcess::waitProcess ($serverPid,
(0x0e08+ 5919-0x2518)));if (NXTerminate::checkProcessBeforeKill ($serverPid,
"\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 if (Common::NXProcess::sigkill (
$serverPid)){if ((not (unlink ($redisLock)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4b\x69\x6c\x6c\x65\x64\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}}}}sub __getRedisServerPid{(my $redisLockFile=
getRedisPidFile ());(my $pid=(-(0x0318+ 3682-0x1179)));my ($FH);($FH=
main::nxopen ($redisLockFile,$NXBits::O_RDONLY,(0x087f+ 990-0x0c5d)));if ((not (
defined ($FH)))){(my $errorstring=libnxh::NXGetErrorString ());Logger::error (((
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x3a\x20"
.$redisLockFile)."\x3a\x20").$errorstring)."\x2e"));return ((""));}else{(my $r_b
=main::nxread ($FH,(\$pid),(0x16d2+ 3885-0x23ff)));main::nxclose ($FH);if (($r_b
==(0x1467+ 1689-0x1b00))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x70\x69\x64\x20\x69\x6e\x3a\x20"
.$redisLockFile)."\x2e"));}}return ($pid);}sub __getCommandNameFromLine{(my $cmdLine
=shift (@_));(my $commandName=(""));(($commandName)=($cmdLine=~ /command=(.*),service/ )
);if (($commandName eq (""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6e\x61\x6d\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$cmdLine)."\x27\x2e"));}return ($commandName);}sub __checkCommandLine{(my $ref_msg
=shift (@_));(my $msg=$$ref_msg);if ((($msg=~ /key=\n/ )or ($msg=~ /key=,/ ))){
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6b\x65\x79\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));
return ((0x0a5f+ 4071-0x1a45));}if ((($msg=~ / / )and (not (($msg=~ /command=script,service=db,/ )
)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x61\x69\x6e\x20\x73\x70\x61\x63\x65\x73\x2e"
));return ((0x1084+ 2639-0x1ad2));}if (($msg=~ /^(.*),field=(.*),value=,/ )){
Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x69\x65\x6c\x64\x20".$2).
"\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27").$msg
)."\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));(
$$ref_msg=~ s/,field=$2,value=,/,/ );return (__checkCommandLine ($ref_msg));}if 
(($msg=~ /^(.*),field=(.*),value=\n/ )){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x69\x65\x6c\x64\x20".$2).
"\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27").$msg
)."\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));(
$$ref_msg=~ s/,field=$2,value=\n/\n/ );return (__checkCommandLine ($ref_msg));}
if ((($msg=~ /=,/ )or ($msg=~ /=\n/ ))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x65\x6d\x70\x74\x79\x20\x66\x69\x65\x6c\x64\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg)."\x27\x2e"));return ((0x0007+ 6086-0x17cc));}if ((not (($msg=~ /\n$/ ))))
{Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6d\x69\x73\x73\x69\x6e\x67\x20\x6e\x65\x77\x20\x6c\x69\x6e\x65\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x20\x61\x74\x20\x74\x68\x65\x20\x65\x6e\x64\x20\x6f\x66\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$msg)."\x27\x2e"));($$ref_msg.="\x0a");return (__checkCommandLine ($ref_msg));}
if ((($msg=~ /command=(hmset|hset|set),service=db/ )and ((not (($msg=~ /field=(.*)/ )
))and (not (($msg=~ /value=(.*)/ )))))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6e\x6f\x74\x68\x69\x6e\x67\x2e"
));return ((0x00e1+ 4337-0x11d1));}if (((length ($msg)>16383)and (not (($msg=~ /command=evalsha,service=db,/ )
)))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x69\x73\x20\x6c\x6f\x6e\x67\x65\x72\x20\x74\x68\x61\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x6d\x61\x78\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x73\x20\x73\x65\x74\x74\x69\x6e\x67\x73\x3a\x20\x31\x36\x33\x38\x33\x2e"
);return ((0x0f29+ 329-0x1071));}return ((0x1cef+  20-0x1d03));}sub 
resendWaitingCommands{(my $resend=(0x080d+ 7705-0x2626));(my (@newCommandList)=
());unless (@sendCommandList){return ((0x0059+ 7019-0x1bc4));}(my (
@tmpCommandList)=@sendCommandList);(@waitingCommandList=());(@sendCommandList=()
);foreach my $command (@tmpCommandList){if (($command=~ /command=connect/ )){
next;}if (($command=~ /command=auth/ )){next;}if ((sendToDb ($command)==
(0x016a+ 2373-0x0aaf))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x72\x65\x73\x65\x6e\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$command)."\x2e"));last;}else{push (@newCommandList,$command);}}if (
@newCommandList){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x72\x65\x73\x65\x6e\x64\x20"
.join ($",@newCommandList))."\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x73\x2e"));(
$resendSuccess=(0x1044+ 2605-0x1a70));(@waitingCommandList=@newCommandList);(
@sendCommandList=@newCommandList);return ((0x1876+ 3603-0x2688));}return (
(0x1915+ 1754-0x1fef));}sub checkFailure{if (checkRedisFlock ()){($connected=
(0x19a1+ 3036-0x257d));(my $redisLockFile=getRedisLockFile ());if ((
Common::NXFile::fileExists ($redisLockFile)==(0x056d+ 1976-0x0d24))){unlink (
$redisLockFile);}}if ((($connected==(0x0142+ 7012-0x1ca6))or (
__checkIfActualRedisServerPid ()==(0x1394+ 309-0x14c9)))){($connected=
(0x12a6+ 4539-0x2461));$selector->remove ($readRedis);$selector->remove (
$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});if ((resendWaitingCommands ()==
(0x097a+ 5327-0x1e48))){return ((0x0b45+ 6718-0x2583));}return (
(0x0991+ 5806-0x203e));}return ((0x0823+ 1484-0x0def));}sub 
__checkIfActualRedisServerPid{my ($actualRedisServerPid);if (($redisServerPid==(
-(0x0468+ 4420-0x15ab)))){return ((0x0acf+ 2604-0x14fb));}if ((
Common::NXFile::fileExists (getRedisLockFile ())==(0x12f8+ 5078-0x26cd))){(
$actualRedisServerPid=__getRedisServerPid ());}else{return (
(0x105d+ 1354-0x15a7));}if (($actualRedisServerPid==$redisServerPid)){return (
(0x2263+ 632-0x24da));}return ((0x1f01+ 855-0x2258));}sub 
prepareMultipleCommands{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x6d\x75\x6c\x74\x69\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub executeCommands{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x65\x63\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub executeCommandsAndSave{sendToDbAndSave (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x65\x63\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub isConnected{return ($connected);}sub setDisconnected{($connected=
(0x08a8+ 5942-0x1fde));}sub __handleRedisErrorIfPossible{(my $response=shift (@_
));if (($response=~ /LOADING Redis is loading the dataset in memory/ )){
resendWaitingCommands ();return ((0x184a+ 2392-0x21a1));}elsif (($response=~ /ERR unknown command/ )
){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x75\x6e\x6b\x6e\x6f\x77\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x08d2+ 3485-0x166f)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67"));shift (@waitingCommandList);shift (
@sendCommandList);resendWaitingCommands ();return ((0x0b11+ 4909-0x1e3d));}elsif
 (($response=~ /Error compiling script/ )){main::nxexit ((0x14da+ 1269-0x19cf));
}elsif (($response=~ /Error running script/ )){main::nxexit (
(0x10d8+ 3106-0x1cfa));}elsif (($response=~ /WRONGTYPE/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x72\x6f\x6e\x67\x20\x74\x79\x70\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x039b+ 5502-0x1919)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x2e"));shift (@waitingCommandList);
shift (@sendCommandList);resendWaitingCommands ();return ((0x1b39+ 141-0x1bc5));
}elsif (($response=~ /ERR wrong number of arguments/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x72\x6f\x6e\x67\x20\x6e\x75\x6d\x62\x65\x72\x20\x6f\x66\x20\x61\x72\x67\x75\x65\x6d\x6e\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x002f+ 5949-0x176c)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x2e"));shift (@waitingCommandList);
shift (@sendCommandList);resendWaitingCommands ();return ((0x10d0+ 2140-0x192b))
;}elsif (($response=~ /NOSCRIPT No matching script/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x73\x63\x72\x69\x70\x74\x20\x27"
.$waitingCommandList[(0x0b14+ 2662-0x157a)]).
"\x27\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
));shift (@waitingCommandList);shift (@sendCommandList);
NXRedisScript::loadAllScriptsToDb ();return ((0x0d89+ 2224-0x1638));}return (
(0x09af+ 2100-0x11e3));}sub saveRedisPid{(my $pidFile=getRedisPidFile ());(my $PID_FH
=main::nxopen ($pidFile,(($NXBits::O_WRONLY+$NXBits::O_CREAT)+$NXBits::O_TRUNC),
(($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)));if (defined 
($PID_FH)){main::nxwrite ($PID_FH,$ $);
 main::nxclose ($PID_FH);if (
main::effectiveUserIsAdministrator ()){my ($errorMsg);if ((
Common::NXFile::setOwnershipForUserNX ($pidFile,(\$errorMsg))==(-
(0x0fb2+ 3964-0x1f2d)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20\x27"
.$pidFile)."\x27\x20").$errorMsg)."\x2e"));}}}else{(my $error=
libnxh::NXGetErrorName ());Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x74\x6f\x20\x73\x61\x76\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x70\x69\x64\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$error)."\x2e"));}}sub checkIfLastOperationWentOk{($errorDuringLastCommand=
(0x028d+ 4972-0x15f9));(my $result=get ());if ((($result ne (""))and (
$errorDuringLastCommand==(0x1d62+ 133-0x1de7)))){return ((0x1753+ 2903-0x22a9));
}return ((0x09cc+ 3168-0x162c));}sub checkIfSubscriptionShouldBeStarted{if ((
$serverInit==(0x1c4f+ 1323-0x217a))){return ((0x030d+ 2293-0x0c01));}elsif (
Server::isDaemonProcess ()){return ((0x03fa+ 6634-0x1de3));}else{return (
(0x0d50+ 2996-0x1904));}}sub setServerType{(my $type=shift (@_));(my $name=(""))
;sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x67\x65\x74\x6e\x61\x6d\x65\x0a"
);(my $oldName=get ());($oldName=main::urldecode ($oldName));if ((($oldName eq 
(""))or ($oldName eq "\x6e\x6f\x74\x20\x73\x65\x74"))){($name=$type);}else{(
$name=(($oldName."\x20").$type));}($name=main::urlencode ($name));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x73\x65\x74\x6e\x61\x6d\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$name)."\x0a"));}sub unsetServerType{(my $type=shift (@_));(my $name=(""));
sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x67\x65\x74\x6e\x61\x6d\x65\x0a"
);(my $oldName=get ());($oldName=main::urldecode ($oldName));if (($oldName=~ /$type/ )
){($name=$oldName);($name=~ s/ \b$type\b// );($name=~ s/\b$type\b *// );if ((
$name eq (""))){($name="\x6e\x6f\x74\x20\x73\x65\x74");}($name=main::urlencode (
$name));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x73\x65\x74\x6e\x61\x6d\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$name)."\x0a"));}}sub handleCommandSuccesful{(my $command=shift (@_));if ((
$command eq (""))){return ((0x0f5a+ 3099-0x1b75));}if (($command=~ /command=(.*),error=0/ )
){if (($command=~ /command=multi/ )){($multiCommand=(0x0a02+ 2266-0x12db));
return ((0x1603+ 4279-0x26ba));}if ((($command=~ /command=exec/ )and (
$multiCommand>(0x0737+ 339-0x088a)))){splice (@sendCommandList,
(0x0551+ 7926-0x2447),($multiCommand+(0x0e62+ 1024-0x1261)));($multiCommand=
(0x0542+ 7246-0x2190));return ((0x1ae7+ 560-0x1d17));}if (($multiCommand>
(0x23e7+ 441-0x25a0))){(++$multiCommand);return ((0x1c0d+ 220-0x1ce9));}(my $firstSendCommand
=__getCommandNameFromLine ($sendCommandList[(0x0a6c+ 3841-0x196d)]));if ((
$command=~ /command=(.*),error/ )){(my $receivedCommand=$1);if ((
$receivedCommand eq $firstSendCommand)){shift (@sendCommandList);return (
(0x17dc+ 1464-0x1d94));}else{Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x55\x6e\x65\x78\x70\x65\x63\x74\x65\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x27"
.$command)."\x27\x2e\x20\x57\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x27").
$firstSendCommand)."\x27\x2e"));(my $secondSendCommand=__getCommandNameFromLine 
($sendCommandList[(0x0ac2+ 5411-0x1fe4)]));if (($receivedCommand eq 
$secondSendCommand)){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$firstSendCommand).
"\x27\x20\x69\x73\x20\x6d\x69\x73\x73\x69\x6e\x67\x2e\x20\x50\x72\x6f\x63\x65\x65\x64\x20\x77\x69\x74\x68\x20\x73\x65\x63\x6f\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));shift (@sendCommandList);shift (@sendCommandList);return (
(0x0771+ 933-0x0b16));}return ((0x067b+ 1570-0x0c9c));}}}elsif ((($command=~ /command=(.*),error=(\d+)/ )
or ($connected==(0x0a6c+ 3041-0x164d)))){if ((__handleRedisErrorIfPossible (
$response)==(0x09c9+ 6670-0x23d6))){return ((0x1856+ 807-0x1b7c));}return (
(0x2077+ 1234-0x2549));}}sub commandMonitor{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x6d\x6f\x6e\x69\x74\x6f\x72\x20\x72\x65\x64\x69\x73\x2e"
);sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x6d\x6f\x6e\x69\x74\x6f\x72\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);(@sendCommandList=());while ((0x1f8b+ 1103-0x23d9)){(my (@ready)=$selector->
can_read ((0x0e69+ 8691-0x24a4)));foreach my $fh (@ready){if (($fh eq $readRedis
)){my ($read_buf);(my $bytes_read=main::nxread ($readRedis,(\$read_buf),32768));
if ((($bytes_read eq (0x0ec6+ 5742-0x2534))or ($bytes_read eq ("")))){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x53\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x0742+ 1097-0x0b8b));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x4d\x6f\x6e\x69\x74\x6f\x72\x20\x72\x65\x74\x75\x72\x6e\x3a\x20"
.$response)."\x2e"));main::nxwrite (main::nxgetSTDOUT (),$response);}}}if (
NXShell::isExitRequestReceivedSIGINT ()){$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});$selector->remove ($readRedis);main::nxclose (
$readRedis);($readRedis=(""));($connected=(0x00bd+ 4103-0x10c4));return ((""));}
}}sub commandDebug{(my $param=shift (@_));(my (@params)=split ( / / ,$param,
(0x0f20+ 307-0x1053)));shift (@params);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.join ($",@params))."\x2e"));(my $command=shift (@params));(my $key=shift (
@params));if (($command eq (""))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x0a7f+ 2172-0x12fb));}(my $redisCommand=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d".$command).
"\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62"));if (($key ne (""))){(
$redisCommand.=("\x2c\x6b\x65\x79\x3d".$key));}foreach my $field (@params){(
$redisCommand.=("\x2c\x66\x69\x65\x6c\x64\x3d".$field));}($redisCommand.="\x0a")
;sendToDb ($redisCommand);main::nxwrite (main::nxgetSTDOUT (),(get ()."\x0a"));}
sub commandInfo{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x69\x6e\x66\x6f\x20\x72\x65\x64\x69\x73\x2e"
);sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x69\x6e\x66\x6f\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);(@sendCommandList=());while ((my (@ready)=$selector->can_read (
(0x15c1+ 3046-0x15ef)))){foreach my $fh (@ready){if (($fh eq $readRedis)){my (
$read_buf);(my $bytes_read=main::nxread ($readRedis,(\$read_buf),32768));if (((
$bytes_read eq (0x1b24+ 561-0x1d55))or ($bytes_read eq ("")))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x73\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x0b45+ 5518-0x20d3));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x49\x6e\x66\x6f\x20\x72\x65\x74\x75\x72\x6e\x3a\x20"
.$response)."\x2e"));main::nxwrite (main::nxgetSTDOUT (),$response);closeDb ();
return;}}}}}sub commandScript{(my $param=shift (@_));(my (@params)=split ( / / ,
$param,(0x0639+ 333-0x0786)));shift (@params);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x73\x63\x72\x69\x70\x74\x3a\x20"
.join ($",@params))."\x2e"));(my $scriptName=shift (@params));if (($scriptName 
eq (""))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x53\x63\x72\x69\x70\x74\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x11a8+ 2673-0x1c19));}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x63\x72\x69\x70\x74");(my (@args)=());(my $returnValue
=NXRedisScript::executeScript ($scriptName,(\@args),(\@params)));if ((
$scriptName eq 
"\x67\x65\x74\x41\x6c\x6c\x44\x61\x74\x61\x46\x72\x6f\x6d\x53\x65\x74")){(
$returnValue=~ s/^"// );($returnValue=~ s/"$// );(my (@data)=split ( /" "/ ,
$returnValue,(0x13b8+ 4517-0x255d)));foreach my $singleData (@data){(my (%hash)=
split ( / / ,$singleData,(0x0ebb+ 267-0x0fc6)));foreach my $key (keys (%hash)){
main::nxwrite (main::nxgetSTDOUT (),((($key."\x3a\x20").$hash{$key})."\x0a"));}
main::nxwrite (main::nxgetSTDOUT (),"\x0a");}}else{main::nxwrite (
main::nxgetSTDOUT (),$returnValue);}}sub checkFailCounter{(++$failCounter);if ((
$failCounter==(0x034d+ 3939-0x12af))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x63\x65\x20\x63\x6f\x6e\x65\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x2e"
);}elsif (($failCounter==(0x0bf0+ 3509-0x19a3))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x74\x77\x69\x63\x65\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x2e"
);}if (($failCounter>(0x0d39+ 6530-0x26b9))){if (($finalizeProcessStarted==
(0x06f0+ 4977-0x1a60))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x20"
.$failCounter).
"\x20\x74\x69\x6d\x65\x73\x2e\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x61\x72\x74\x65\x64\x2e"
));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x20"
.$failCounter).
"\x20\x74\x69\x6d\x65\x73\x2e\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));main::nxexit ((0x1ccd+ 1763-0x23b0));}}return;}sub forceCloseRedisClient{(
$connected=(0x0320+ 1655-0x0996));closeDb ();}sub 
checkFailCounterAndCloseIfNeeded{if (($serverInit==(0x0e89+ 3847-0x1d8f))){
return;}if (($failCounter>(0x1b66+ 963-0x1f28))){shift (@sendCommandList);
forceCloseRedisClient ();}checkFailCounter ();}sub cleanCommandList{while ((
scalar (@sendCommandList)>(0x164a+ 2100-0x1e7e))){get ();}}sub isSaveDone{(my $response
=shift (@_));if ((($response eq "\x4f\x4b")or ($response eq 
"\x42\x61\x63\x6b\x67\x72\x6f\x75\x6e\x64\x20\x73\x61\x76\x69\x6e\x67\x20\x73\x74\x61\x72\x74\x65\x64"
))){return ((0x0a19+ 4582-0x1bfe));}return ((0x08a4+ 1225-0x0d6d));}sub 
waitForAllCommands{while ((scalar (@sendCommandList)>(0x18e3+ 1287-0x1dea))){(my $command
=__getCommandNameFromLine ($sendCommandList[(0x0ffd+ 152-0x1095)]));
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$command)."\x27\x2e"));get ();}}sub doNotCloseRedisThreadsOnExit{(
$doNotCloseRedisThreadsWhenFreePerl=(0x12a0+ 3720-0x2127));}
NXMsg::register_error ("\x4e\x58\x52\x65\x64\x69\x73",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4e\x78\x73\x65\x72\x76\x65\x72\x53\x68\x75\x74\x64\x6f\x77\x6e"
,(0x1091+ 1097-0x12e6));"\x3f\x3f\x3f";
